
const sortBoundaries = boundaries => {
    // backwards sort (since marks are inserted right to left)
    boundaries.sort(function(a, b) {
        if (a.index !== b.index) {
            return b.index - a.index;
        } else if (a.type === 'stop' && b.type === 'start') {
            return 1;
        } else if (a.type === 'start' && b.type === 'stop') {
            return -1;
        } else {
            return 0;
        }
    });
}

export default function getBoundaries(ranges) {
    let boundaries = [];
    ranges.forEach(function(range) {
        boundaries.push({
            type: 'start',
            index: range[0],
            className: range.className
        });
        boundaries.push({
            type: 'stop',
            index: range[1]
        });
    });

    sortBoundaries(boundaries);
    return boundaries;
}
